'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _contextSubscribe = require('../lib/contextSubscribe');

var _state = require('../lib/state');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var tabbordionInstances = 0;
var tabbordionUniqId = 0;

function getStateBem(props) {
    return {
        bemModifiers: props.bemModifiers,
        bemSeparator: props.bemSeparator,
        blockElements: props.blockElements
    };
}

function getStateTabbordion(context, props, state) {
    var panels = (0, _state.getArray)(state.stateful ? state.panels : props.panels);

    return {
        animateContent: props.animateContent,
        checkedPanels: panels.filter(_state.getChecked).map(_state.getIndex),
        disabledPanels: panels.filter(_state.getDisabled).map(_state.getIndex),
        firstVisiblePanel: context.firstVisibleIndex,
        lastVisiblePanel: context.lastVisibleIndex,
        panelName: props.name || context.uniqId,
        panelType: props.mode === 'multiple' ? 'checkbox' : 'radio',
        tabbordionId: props.id || context.uniqId
    };
}

function identity(value) {
    return value;
}

var Tabbordion = function (_PureComponent) {
    _inherits(Tabbordion, _PureComponent);

    function Tabbordion(props) {
        _classCallCheck(this, Tabbordion);

        var _this = _possibleConstructorReturn(this, (Tabbordion.__proto__ || Object.getPrototypeOf(Tabbordion)).call(this, props));

        tabbordionInstances++;
        _this.uniqId = 'tabbordion-' + tabbordionUniqId;
        tabbordionUniqId++;

        _this.getNextState = _this.getNextState.bind(_this);
        _this.onChange = _this.onChange.bind(_this);

        _this.firstVisibleIndex = null;
        _this.lastVisibleIndex = null;

        // panels always overrides initialPanels
        _this.state = _this.getNextState(props, { stateful: false }, Array.isArray(props.panels) ? props.panels : props.initialPanels);

        // context subscribers
        _this.subscribers = {
            bem: [],
            tabbordion: []
        };

        _this.childContext = {
            bem: {
                getState: function getState() {
                    return _this.bemState;
                },
                subscribe: (0, _contextSubscribe.addSubscriber)(_this.subscribers.bem),
                unsubscribe: (0, _contextSubscribe.removeSubscriber)(_this.subscribers.bem)
            },
            tabbordion: {
                getState: function getState() {
                    return _this.tabbordionState;
                },
                onChangePanel: _this.onChange,
                subscribe: (0, _contextSubscribe.addSubscriber)(_this.subscribers.tabbordion),
                unsubscribe: (0, _contextSubscribe.removeSubscriber)(_this.subscribers.tabbordion)
            }
        };

        _this.bemState = getStateBem(props);
        _this.tabbordionState = getStateTabbordion(_this, props, _this.state);
        return _this;
    }

    _createClass(Tabbordion, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            var nextState = this.getNextState(nextProps, this.state);
            // only update if there were changes to the local component state
            if (nextState !== this.state) {
                this.setState(nextState);
            }

            var bemState = getStateBem(nextProps);

            if ((0, _state.isShallowlyDifferent)(bemState, this.bemState)) {
                this.subscribers.bem.forEach(function (component) {
                    return component.forceUpdate();
                });
                this.bemState = bemState;
            }

            var tabbordionState = getStateTabbordion(this, nextProps, nextState);

            if ((0, _state.isShallowlyDifferent)(tabbordionState, this.tabbordionState)) {
                this.subscribers.tabbordion.forEach(function (component) {
                    return component.forceUpdate();
                });
                this.tabbordionState = tabbordionState;
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            tabbordionInstances--;
            if (tabbordionInstances === 0) tabbordionUniqId = 0;
        }
    }, {
        key: 'getChildContext',
        value: function getChildContext() {
            return this.childContext;
        }

        /*
         * Controls props and does those nasty little staties we kills them My Precious, *gollum* *gollum*
         * @param {object} props Props received by the component
         * @param {object} prevState State contained in the component
         * @param {array} initialPanels Initial panels state when component is mounted as a stateful component
         * @return {object} State to be used by the component
         */

    }, {
        key: 'getNextState',
        value: function getNextState(props, prevState, initialPanels) {
            var panels = (0, _state.getArray)(prevState.stateful ? prevState.panels : initialPanels || props.panels);
            var panelProps = [];
            var usedIndexes = [];
            var invalidIndexes = [];

            var allowMultiChecked = props.mode === 'multiple';
            // fragments force us to do some recursive looping to find our actual children as React.Children does not do it
            var childPool = [props.children];
            // this logic probably needs to be refactored so that panels register to tabbordion
            while (childPool.length) {
                _react.Children.forEach(childPool.shift(), function (child) {
                    if (child == null || !child.type) {
                        return;
                    }

                    var props = child.props || child._store && child._store.props || {};

                    if (child.type === _react2.default.Fragment && props.children) {
                        childPool.push(props.children);
                    } else if (child.type.contextTypes && child.type.contextTypes.tabbordion) {
                        // use false to mark panels with invalid index
                        var index = props.index != null ? props.index : false;
                        // missing index and duplicates are invalid
                        var isInvalidIndex = index === false || usedIndexes.includes(index);

                        if (isInvalidIndex) {
                            invalidIndexes.push(panelProps.length);
                        } else {
                            usedIndexes.push(index);
                        }

                        panelProps.push({
                            checked: props.checked,
                            disabled: props.disabled,
                            index: isInvalidIndex ? false : index,
                            visible: props.visible
                        });
                    }
                });
            }

            // time to fix invalid index values
            var unusedIndex = 0;

            while (invalidIndexes.length > 0) {
                // find the next usable index value
                while (usedIndexes.includes(unusedIndex)) {
                    unusedIndex++;
                }
                // use the index value
                panelProps[invalidIndexes.shift()].index = unusedIndex;
                // try another index on the next round
                unusedIndex++;
            }

            // now that we know the indexes we can link to existing data; if it happens to exist, of course
            var checkedCount = 0;
            var firstVisibleIndex = null;
            var lastVisibleIndex = null;

            var nextPanels = panelProps.map(function (props, index) {
                var panel = panels.find(function (panel) {
                    return panel.index === props.index;
                }) || { checked: checked, disabled: disabled, visible: visible };

                var checked = (props.checked != null ? props.checked : !!panel.checked) && (allowMultiChecked || checkedCount === 0);

                var disabled = props.disabled != null ? props.disabled : !!panel.disabled;
                var visible = props.visible != null ? props.visible : panel.visible === false ? false : true;

                if (visible) {
                    lastVisibleIndex = index;
                    if (firstVisibleIndex == null) firstVisibleIndex = lastVisibleIndex;
                }

                if (checked && visible) checkedCount++;

                return {
                    checked: checked,
                    disabled: disabled,
                    index: props.index,
                    visible: visible
                };
            });

            if (firstVisibleIndex != null) {
                // one panel must always be checked in single mode
                if (checkedCount === 0 && props.mode !== 'multiple' && props.mode !== 'toggle') {
                    nextPanels[firstVisibleIndex].checked = true;
                }
                // it is now safe to use the actual indexes instead of references
                firstVisibleIndex = nextPanels[firstVisibleIndex].index;
                lastVisibleIndex = nextPanels[lastVisibleIndex].index;
            }

            // keep in local state: We can do this in this way because these values are derived from main panels state.
            //                      Also, this state is updated each time props change, thus we maintain "pureness".
            this.firstVisibleIndex = firstVisibleIndex;
            this.lastVisibleIndex = lastVisibleIndex;

            // determine who will own the state
            var stateful = !props.onChange || !props.onPanels || !Array.isArray(props.panels);

            if (stateful) {
                // it is mine, my own, My Preciouss...
                if (!prevState.stateful || (0, _state.isShallowlyDifferentArray)(prevState.panels, nextPanels)) {
                    if (props.onPanels) props.onPanels(nextPanels);

                    return {
                        panels: nextPanels,
                        stateful: stateful
                    };
                }
            } else {
                // provide updated state to whomever will own it
                if ((0, _state.isShallowlyDifferentArray)(panels, nextPanels)) {
                    props.onPanels(nextPanels);
                }
                // clear local state
                if (prevState.stateful) {
                    return { panels: null, stateful: stateful };
                }
            }

            return prevState;
        }
    }, {
        key: 'onChange',
        value: function onChange(index) {
            var mode = this.props.mode;


            if (!this.state.stateful) {
                this.props.onChange({
                    index: index,
                    mode: mode
                });
                return;
            }

            // we can mutate this state as we please because we own this state
            var panel = this.state.panels.find(function (panel) {
                return panel.index === index;
            });

            if (panel == null) {
                throw new Error('Unexpected invalid panel index: ' + index);
            }

            var didMutate = false;

            switch (mode) {
                case 'toggle':
                    // only one can be active, but also none can be active (radio, but allow unselect)
                    this.state.panels.forEach(function (togglePanel) {
                        if (togglePanel !== panel && togglePanel.checked) {
                            togglePanel.checked = false;
                        }
                    });
                    panel.checked = !panel.checked;
                    didMutate = true;
                    break;
                case 'multiple':
                    // no state restrictions/relations (checkbox)
                    panel.checked = !panel.checked;
                    didMutate = true;
                    break;
                default:
                    // only one panel must stay active (radio)
                    this.state.panels.forEach(function (togglePanel) {
                        if (togglePanel !== panel && togglePanel.checked) {
                            togglePanel.checked = false;
                            didMutate = true;
                        }
                    });
                    if (!panel.checked) {
                        panel.checked = true;
                        didMutate = true;
                    }
            }

            if (didMutate) {
                this.setState({ panels: this.state.panels.slice(0) });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            // use destructuring to pick out props we don't need to pass to the rendered component
            var _props = this.props,
                animateContent = _props.animateContent,
                children = _props.children,
                Component = _props.component,
                bemModifiers = _props.bemModifiers,
                bemSeparator = _props.bemSeparator,
                blockElements = _props.blockElements,
                component = _props.component,
                initialPanels = _props.initialPanels,
                mode = _props.mode,
                name = _props.name,
                onChange = _props.onChange,
                onPanels = _props.onPanels,
                panelsProp = _props.panels,
                props = _objectWithoutProperties(_props, ['animateContent', 'children', 'component', 'bemModifiers', 'bemSeparator', 'blockElements', 'component', 'initialPanels', 'mode', 'name', 'onChange', 'onPanels', 'panels']);

            var panel = 0;

            var panels = this.state.stateful ? this.state.panels : panelsProp;
            var childPool = [children];
            var clones = [];

            while (childPool.length) {
                _react.Children.forEach(childPool.shift(), function (child) {
                    if (child == null || !child.type) {
                        clones.push(child);
                    } else if (child.type === _react2.default.Fragment) {
                        childPool.push(child.props.children);
                    } else if (child.type.contextTypes && child.type.contextTypes.tabbordion) {
                        var clone = _react2.default.cloneElement(child, panels[panel]);
                        panel++;
                        clones.push(clone);
                    } else {
                        clones.push(child);
                    }
                });
            }

            return _react2.default.createElement(
                Component,
                _extends({}, props, { role: 'tablist' }),
                _react.Children.map(clones, identity)
            );
        }
    }]);

    return Tabbordion;
}(_react.PureComponent);

Tabbordion.childContextTypes = {
    bem: _propTypes2.default.object,
    tabbordion: _propTypes2.default.object
};

Tabbordion.defaultProps = {
    animateContent: false,
    bemModifiers: {
        animated: 'animated',
        between: 'between',
        checked: 'checked',
        content: 'content',
        disabled: 'disabled',
        enabled: 'enabled',
        first: 'first',
        hidden: 'hidden',
        last: 'last',
        noContent: 'no-content',
        unchecked: 'unchecked'
    },
    bemSeparator: '--',
    blockElements: {
        animator: 'panel__animator',
        content: 'panel__content',
        label: 'panel__label',
        panel: 'panel'
    },
    component: 'ul',
    mode: 'single'
};

var tabbordionPanelProps = _propTypes2.default.arrayOf(_propTypes2.default.shape({
    checked: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    index: _propTypes2.default.number,
    visible: _propTypes2.default.bool
}));

Tabbordion.propTypes = {
    animateContent: _propTypes2.default.oneOf([false, 'height', 'marginTop']),
    bemModifiers: _propTypes2.default.shape({
        between: _propTypes2.default.string,
        checked: _propTypes2.default.string,
        content: _propTypes2.default.string,
        disabled: _propTypes2.default.string,
        enabled: _propTypes2.default.string,
        first: _propTypes2.default.string,
        hidden: _propTypes2.default.string,
        last: _propTypes2.default.string,
        noContent: _propTypes2.default.string,
        unchecked: _propTypes2.default.string
    }),
    bemSeparator: _propTypes2.default.string,
    blockElements: _propTypes2.default.shape({
        content: _propTypes2.default.string,
        label: _propTypes2.default.string,
        panel: _propTypes2.default.string
    }),
    children: _propTypes2.default.node,
    className: _propTypes2.default.string,
    component: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object, _propTypes2.default.string]),
    id: _propTypes2.default.string,
    initialPanels: tabbordionPanelProps,
    mode: _propTypes2.default.oneOf(['single', 'toggle', 'multiple']),
    name: _propTypes2.default.string,
    onChange: _propTypes2.default.func,
    onPanels: _propTypes2.default.func,
    panels: tabbordionPanelProps
};

exports.default = Tabbordion;